	SUBROUTINE BINARY_EXCLUDE_BY_PHASE(PARAMETRS,MAXNUMPARAM,TIME,
	1FILETYPE_VEL,EXCLUDED_PHASES,MAXNUMPHASES,NPAIRS,EXCLUDE)
C
C	This subroutine determines whether a spectroscopic binary
C  data point should be excluded based on the value of its phase
C  compared to a set of user established set of pairs of forbidden
C  phase limits.  
C			Donald H. Gudehus, December 14, 1999
C
	CHARACTER*11 FILETYPE_VEL
	LOGICAL EXCLUDE
	REAL*8 PARAMETRS(MAXNUMPARAM),TIME,TIME_WORK,
	1EXCLUDED_PHASES(MAXNUMPHASES),PHASE
C
	IF (FILETYPE_VEL.EQ.'BY_VELOCITY') THEN
	  TIME_WORK=TIME
	ELSE IF (FILETYPE_VEL.EQ.'JD_VELOCITY') THEN
	  CALL JD_BY(TIME,TIME_WORK)
	END IF
C
	PHASE=MOD((TIME_WORK-PARAMETRS(2)),PARAMETRS(1))/PARAMETRS(1)
	IF (PHASE.LT.0.0) PHASE=PHASE+1.0D0
	EXCLUDE=.FALSE.
	DO I=1,NPAIRS*2-1,2
C  Sometimes it's convenient to give the upper limit excluded phase
C  as greater than 1.  Handle that case first.
	  IF (EXCLUDED_PHASES(I+1).GT.1.0D0) THEN
	    IF (PHASE.GE.EXCLUDED_PHASES(I).OR.
	1   (PHASE+1.0D0).LE.EXCLUDED_PHASES(I+1)) EXCLUDE=.TRUE.
	  ELSE
	    IF (PHASE.GE.EXCLUDED_PHASES(I).AND.
	1   PHASE.LE.EXCLUDED_PHASES(I+1)) EXCLUDE=.TRUE.
	  END IF
	END DO
C
	RETURN
	END
	  
