	SUBROUTINE BY_JD(BY,JD)
C
C	This subroutine computes the Julian date, given the Besselian year.
C  Note that JD is not an integer in this subroutine,
C  i.e., it reprsents the Julian date rather than the Julian day number.
C  The fractional part will be zero at noon, UT.
C			Donald H. Gudehus, June 12, 1995
C			Version 2, May 16, 2005
C			Keivan G. Stassun pointed out a discrepancy in
C			the output of this subroutine.  This was caused by
C			a misinterpretation of Table 14.13 in the 
C			Explanatory Supplement (1961 ed.).  The zero point
C			correction for years after 1924 given there was only
C			internal to that table.  The revised code is based
C			on Lieske, J. H. 1979, Astron & Astrophysics, 73, 282.
C
	REAL*8 JD,BY
C
C  The fundamental epoch of the Besselian year is 1900.0 or 1900
C  January 0.81352 E.T., where Jan. 0.0 denotes Greenwich midnight of the
C  preceding day.
	JD=2415020.31352D0+(BY-1900.0D0)*365.242198781D0
C
	RETURN
	END
