	SUBROUTINE COFACTOR(MATRIX,MINORARRAY,SIZE,ROW,COLUMN,
	1ORDER,MINOR,SIGN,KPVT)
C
C       This subroutine computes the minor of the input matrix
C  and the sign.  The signed minor is the cofactor.  Note that the
C  order of indexes is row, column which is backwards from indexes
C  for pictures and cartesian coordinates.
C			Donald H. Gudehus, September, 1982
C			Version 2, D. H. G., November 10, 2013
C			Modified code to also be compatible with
C			64-bit systems
C
C	MATRIX		(C)	The array of the matrix
C	MINORARRAY	(R)	The minor array
C	SIZE		(C)	The dimension of MATRIX and MINORARRAY
C				as defined in the calling routine.
C	ROW		(C)	The row defining the minor
C	COLUMN		(C)	The column defining the minor
C	ORDER		(C)	The order of the matrix in the array
C				MATRIX
C	MINOR		(R)	The minor of the determinant of the
C				matrix.  The minor = MINOR(1)*10**
C				MINOR(2)
C	SIGN		(R)	The sign of the cofactor
C	KPVT		(R)	A vector of pivot indices
C
	INTEGER*4 ROW,COLUMN,SIZE,ORDER,KPVT(SIZE),ADDRESS1_4,
	1ADDRESS2_4
	INTEGER*8 ADDRESS1_8,ADDRESS2_8
	REAL*8 MATRIX(SIZE,SIZE),MINORARRAY(SIZE,SIZE),
	1MINOR(2),SIGN
C
	INTEGER SYSTEM_NUMBER_BYTES
	COMMON /SYS_NUM_BYTES/ SYSTEM_NUMBER_BYTES
C
C  Create some dynamic memory
	IF (SYSTEM_NUMBER_BYTES.EQ.4) THEN
	  CALL DYNAMIC(ADDRESS1_4,ORDER,'  R8',.TRUE.)
	  CALL DYNAMIC(ADDRESS2_4,ORDER*(ORDER+1)/2,'  R8',.TRUE.)
	  CALL COFACTOR1(MATRIX,MINORARRAY,SIZE,ROW,COLUMN,ORDER,
	1 MINOR,SIGN,KPVT,%VAL(ADDRESS1_4),%VAL(ADDRESS2_4))
	  CALL DYNAMIC(ADDRESS1_4,ORDER,'  R8',.FALSE.)
	  CALL DYNAMIC(ADDRESS2_4,ORDER*(ORDER+1)/2,'  R8',.FALSE.)
	ELSE IF (SYSTEM_NUMBER_BYTES.EQ.8) THEN
	  CALL DYNAMIC(ADDRESS1_8,ORDER,'  R8',.TRUE.)
	  CALL DYNAMIC(ADDRESS2_8,ORDER*(ORDER+1)/2,'  R8',.TRUE.)
	  CALL COFACTOR1(MATRIX,MINORARRAY,SIZE,ROW,COLUMN,ORDER,
	1 MINOR,SIGN,KPVT,%VAL(ADDRESS1_8),%VAL(ADDRESS2_8))
	  CALL DYNAMIC(ADDRESS1_8,ORDER,'  R8',.FALSE.)
	  CALL DYNAMIC(ADDRESS2_8,ORDER*(ORDER+1)/2,'  R8',.FALSE.)
	END IF
C
	RETURN
	END
