	SUBROUTINE DETERMNT(MATRIX,SIZE,ORDER,DET,KPVT)
C
C       This subroutine calculates the determinant of a symmetric
C  matrix.  The maximum order is presently equal to 20.
C			Donald H. Gudehus, December, 1982
C			Version 2, D. H. G., November 10, 2013
C			Modified code to also be compatible with 
C			64-bit systems
C
	INTEGER*4 SIZE,ORDER,KPVT(SIZE),ADDRESS1_4,ADDRESS2_4
	INTEGER*8 ADDRESS1_8,ADDRESS2_8
	REAL*8 MATRIX(SIZE,SIZE),DET(2)
C
	INTEGER SYSTEM_NUMBER_BYTES
	COMMON /SYS_NUM_BYTES/ SYSTEM_NUMBER_BYTES
C
C  Create some dynamic memory
	IF (SYSTEM_NUMBER_BYTES.EQ.4) THEN
	  CALL DYNAMIC(ADDRESS1_4,ORDER,'  R8',.TRUE.)
	  CALL DYNAMIC(ADDRESS2_4,ORDER*(ORDER+1)/2,'  R8',.TRUE.)
	  CALL DETERMNT1(MATRIX,SIZE,ORDER,DET,KPVT,%VAL(ADDRESS1_4),
	1 %VAL(ADDRESS2_4))
	  CALL DYNAMIC(ADDRESS1_4,ORDER,'  R8',.FALSE.)
	  CALL DYNAMIC(ADDRESS2_4,ORDER*(ORDER+1)/2,'  R8',.FALSE.)
	ELSE IF (SYSTEM_NUMBER_BYTES.EQ.8) THEN
	  CALL DYNAMIC(ADDRESS1_8,ORDER,'  R8',.TRUE.)
	  CALL DYNAMIC(ADDRESS2_8,ORDER*(ORDER+1)/2,'  R8',.TRUE.)
	  CALL DETERMNT1(MATRIX,SIZE,ORDER,DET,KPVT,%VAL(ADDRESS1_8),
	1 %VAL(ADDRESS2_8))
	  CALL DYNAMIC(ADDRESS1_8,ORDER,'  R8',.FALSE.)
	  CALL DYNAMIC(ADDRESS2_8,ORDER*(ORDER+1)/2,'  R8',.FALSE.)
	END IF
C
	RETURN
	END
