	SUBROUTINE DPAVERSIGWT(DAT,WEIGHT,NX,NY,IS,JS,IF,JF,AVG,SIGMA)
C
C       This subroutine finds the average and mean error of the double-
C  precision two-dimensional array DAT which is weighted by the 
C  double-precision array WEIGHT.
C			Donald H. Gudehus, January, 1994
C
C	DAT	(C)	The array for the data
C	WEIGHT	(C)	The weighting array
C	NX	(C)	The dimension of the array DAT in the x
C			direction
C	NY	(C)	The dimension of the array DAT in the y
C			direction
C	IS	(C)	The starting index in the x direction
C	JS	(C)	The starting index in the y direction
C	IF	(C)	The ending index in the x direction
C	JF	(C)	The ending index in the y direction
C	AVG	(R)	The weighted average
C	SIGMA	(R)	The mean error for a datum of average weight
C
	REAL*8 DAT(NX,NY),WEIGHT(NX,NY),SUM,SUMWT,NUMPIXELS,AVG,SIGMA
C
	SUM=0.0D0
	SUMWT=0.0D0
	NUMPIXELS=0.0D0
	DO M=JS,JF
	  DO L=IS,IF
	    SUM=SUM+DAT(L,M)*WEIGHT(L,M)
	    SUMWT=SUMWT+WEIGHT(L,M)
	    NUMPIXELS=NUMPIXELS+1.0D0
	  END DO
	END DO
	AVG=SUM/SUMWT
	SUM=0.0D0
	DO M=JS,JF
	  DO L=IS,IF
	    SUM=SUM+(DAT(L,M)-AVG)**2*WEIGHT(L,M)
	  END DO
	END DO
	SIGMA=SQRT(SUM*NUMPIXELS/((NUMPIXELS-1)*SUMWT))
	RETURN
	END
