	SUBROUTINE EQHOR(LATITUDE,HOURANGL,DECLINA,AZIMUTH,ALT,ZEN)
C
C       This subroutine computes the azimuth, altitude, and zenith
C  distance given the hour angle and declination of an object.
C				Donald H. Gudehus, May, 1983
C
C	LATITUDE	(C)	The latitude in decimal degrees
C	HOURANGL	(C)	The hour angle in decimal hours
C	DECLINA		(C)	The declination in decimal degrees
C	AZIMUTH		(R)	The azimuth in decimal degrees
C	ALT		(R)	The altitude in decimal derees
C	ZEN		(R)	The zenith distance in decimal degrees
C
	REAL*8 LATITUDE,HOURANGL,W_HOURANGL,DECLINA,AZIMUTH,ALT,ZEN,
	1SINALT,SINAZCOSALT,COSAZCOSALT
C
	W_HOURANGL=HOURANGL*15.0D0
C
	SINALT=DCOSD(LATITUDE)*DCOSD(W_HOURANGL)*
	1DCOSD(DECLINA)+DSIND(LATITUDE)*DSIND(DECLINA) !  Cosine formula
	SINAZCOSALT=-DSIND(W_HOURANGL)*DCOSD(DECLINA) !  Sine formula
	COSAZCOSALT=-DSIND(LATITUDE)*DCOSD(W_HOURANGL)*
	1DCOSD(DECLINA)+DCOSD(LATITUDE)*DSIND(DECLINA) !  Formula C of Smart
C
	ALT=DASIND(SINALT)
	ZEN=90.0D0-ALT
	IF (COSAZCOSALT.EQ.0.0D0.AND.SINAZCOSALT.EQ.0.0D0) THEN
	  AZIMUTH=0.0D0  ! Zenith
	ELSE
	  AZIMUTH=DATAN2D(SINAZCOSALT,COSAZCOSALT)
	END IF
	IF (AZIMUTH.LT.0.0) AZIMUTH=AZIMUTH+360.0D0
	RETURN
	END
