	SUBROUTINE HOREQ(ALT,AZIMUTH,LATITUDE,LST,
	1DECLINA,HOURANGL,RIGHTASC)
C
C       This subroutine converts from horizon to equatorial coordinates.
C  If the local sidereal time is not available, just input a fake value
C  and ignore the resulting right ascension.
C				Donald H. Gudehus, Nov. 13, 2001
C
C	ALT	 (C)	The altitude in decimal degrees
C	AZIMUTH	 (C)	The azimuth in decimal degrees
C	LATITUDE (C)	The latitude in decimal degrees
C	LST	 (C)	The local sidereal time in decimal hours
C	DECLINA	 (R)	The declination in decimal decrees
C	HOURANGL (R)	The hour angle in decimal hours
C	RIGHTASC (R)	The right ascension in decimal hours
C
	REAL*8 ALT,AZIMUTH,LATITUDE,LST,DECLINA,HOURANGL,RIGHTASC
C
	REAL*8 SINDECLINA,SINHRCOSDEC,COSHRCOSDEC

	SINDECLINA=DCOSD(LATITUDE)*DCOSD(AZIMUTH)*DCOSD(ALT)+
	1DSIND(LATITUDE)*DSIND(ALT) !  Cosine formula
	SINHRCOSDEC=-DSIND(AZIMUTH)*DCOSD(ALT) !  Sine formula
	COSHRCOSDEC=-DSIND(LATITUDE)*DCOSD(AZIMUTH)*DCOSD(ALT)+
	1DCOSD(LATITUDE)*DSIND(ALT) !  Formula C of Smart

	DECLINA=DASIND(SINDECLINA)
C
	IF (COSHRCOSDEC.EQ.0.0D0.AND.SINHRCOSDEC.EQ.0.0D0) THEN
	  HOURANGL=0.0D0
	ELSE
	  HOURANGL=DATAN2D(SINHRCOSDEC,COSHRCOSDEC)
	END IF
C
	HOURANGL=HOURANGL/15.0D0
C
	RIGHTASC=LST-HOURANGL
	IF (RIGHTASC.LT.0.0D0) RIGHTASC=RIGHTASC+24.0D0
C
	RETURN
	END
