	SUBROUTINE JD_BY(JD,BY)
C
C	This subroutine computes the Besselian year, given the
C  Julian date.  Note that JD is not an integer in this subroutine,
C  i.e., it reprsents the Julian date rather than the Julian day number.
C  The fractional part will be zero at noon, UT.
C			Donald H. Gudehus, June 2, 1994
C			Version 2, May 16, 2005
C			Keivan G. Stassun pointed out a discrepancy in
C			the output of this subroutine.  This was caused by
C			a misinterpretation of Table 14.13 in the 
C			Explanatory Supplement (1961 ed.).  The zero point
C			correction for years after 1924 given there was only
C			internal to that table.  The revised code is based
C			on Lieske, J. H. 1979, Astron & Astrophysics, 73, 282.
C
	REAL*8 JD,BY
C
C  The fundamental epoch of the Besselian year is 1900.0 or 1900
C  January 0.81352 E.T. where Jan. 0.0 denotes Greenwich midnight of the 
C  preceding day.  
	BY=1900.0D0+(JD-2415020.31352D0)/365.242198781D0
C
	RETURN
	END
