	SUBROUTINE JD_DATE(JD,DA,MO,YR,DOW)
C
C       This subroutine computes the date and day of week from the 
C  Julian Day number.  BC years are output as negative numbers.  This
C  is based on the HP-67 Gregorian calendar program by D. Gudehus.
C				Donald H. Gudehus, February, 1994
C			Version 2, D. Gudehus, March 7, 2005
C			Made argument list all integer and
C			made all constants double precision
C
C	JD	(C)	The Julian Day number.  The Julian Day number
C			gives the number of days elapsed since noon
C			on January 1, 4713 BC;  note however that this
C			date is based on the Julian calendar (leap year
C			every 4 years and the civil system (no year 0).
C	DA	(R)	The day with the time assumed to be noon.
C	MO	(R)	The month expressed as a number;  range is 1 to 12
C	YR	(R)	The year in the Gregorian calendar.  Note that
C			in the Gregorian proleptic calendar (dates
C			before its inception on October 15, 1582) the
C			year 0 is regarded as a leap year.
C	DOW	(R)	The day of the week given by numbers 0 through
C			6, where 0 stands for Sunday.
C
	INTEGER JD,DA,MO,YR,DOW
C
	INTEGER*4 JDCALC,JDTEMP,K,KKK,YY,YYY,MM
	REAL*8 KKKK
C
C  Chose a value of K which is close to contemporary values
	K=-15
	JDCALC=JD+1
	icount=0
	DO WHILE (JD.NE.JDCALC)
	  JDTEMP=JD-1720997 !  Subtracts Saturday, Oct. 30, -1
	  IF (JDTEMP.GE.123) THEN
	    KKKK=0.0D0
	  ELSE
	    KKKK=365.25D0
	  END IF
	  YY=INT((JDTEMP-122.1D0-K-KKKK)/365.25D0)
	  IF (YY.GE.0.0D0) THEN
	    KKK=0
	    YYY=YY
	  ELSE 
	    KKK=366
	    YYY=YY+1
	  END IF
	  MM=JIDINT((JDTEMP-JIDINT(365.25D0*YYY)-K+KKK)/30.6001D0)
	  DA=JDTEMP-JIDINT(365.25D0*YYY)-JIDINT(30.6001D0*MM)-K+KKK
	  IF (MM.EQ.14.OR.MM.EQ.15) THEN
	    MO=MM-13
	  ELSE IF (MM.LT.14) THEN
	    MO=MM-1
	  END IF
	  IF (MO.EQ.1.OR.MO.EQ.2) THEN
	    YR=YY+1
	  ELSE IF (MO.GT.2) THEN
	    YR=YY
	  END IF
	  CALL DATE_JD(DA,MO,YR,JDCALC,DOW)
	  K=-JIDINT(YYY/100.0D0)+INT(YYY/400.0D0)
	END DO
	RETURN
	END
