	SUBROUTINE MATRIXINV(MATRIX,SIZE,ORDER,INVERSE,KPVT)
C
C       This subroutine inverts a symmetric matrix.  The inversion
C  of a symmetric matrix is itself symmetric.
C			Donald H. Gudehus, December, 1983
C			Version 2, D. H. G., November 11, 2013
C			Modified code to also be compatible with
C			64-bit systems
C
C	MATRIX	(C)	The array containing the matrix elements
C	SIZE	(C)	The dimension of MATRIX and of INVERSE
C	ORDER	(C)	The order of the matrix to be inverted
C	INVERSE	(R)	The array containg the inverted matrix
C	KPVT	(R)	A working array
C	
	INTEGER*4 SIZE,ORDER,KPVT(SIZE),ADDRESS1_4,ADDRESS2_4
	INTEGER*8 ADDRESS1_8,ADDRESS2_8
	REAL*8 MATRIX(SIZE,SIZE),INVERSE(SIZE,SIZE)
C
	INTEGER SYSTEM_NUMBER_BYTES
	COMMON /SYS_NUM_BYTES/ SYSTEM_NUMBER_BYTES
C
C  Create some dynamic memory
	IF (SYSTEM_NUMBER_BYTES.EQ.4) THEN
	  CALL DYNAMIC(ADDRESS1_4,ORDER,'  R8',.TRUE.)
	  CALL DYNAMIC(ADDRESS2_4,ORDER*(ORDER+1)/2,'  R8',.TRUE.)
	  CALL MATRIXINV1(MATRIX,SIZE,ORDER,INVERSE,KPVT,%VAL(ADDRESS1_4),
	1 %VAL(ADDRESS2_4))
	  CALL DYNAMIC(ADDRESS1_4,ORDER,'  R8',.FALSE.)
	  CALL DYNAMIC(ADDRESS2_4,ORDER*(ORDER+1)/2,'  R8',.FALSE.)
	ELSE IF (SYSTEM_NUMBER_BYTES.EQ.8) THEN
	  CALL DYNAMIC(ADDRESS1_8,ORDER,'  R8',.TRUE.)
	  CALL DYNAMIC(ADDRESS2_8,ORDER*(ORDER+1)/2,'  R8',.TRUE.)
	  CALL MATRIXINV1(MATRIX,SIZE,ORDER,INVERSE,KPVT,%VAL(ADDRESS1_8),
	1 %VAL(ADDRESS2_8))
	  CALL DYNAMIC(ADDRESS1_8,ORDER,'  R8',.FALSE.)
	  CALL DYNAMIC(ADDRESS2_8,ORDER*(ORDER+1)/2,'  R8',.FALSE.)
	END IF
C
	RETURN
	END
