	SUBROUTINE NLDER(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,MAXNUMPARAM,
	1FUNCAT,CHOICE,CONSTANTTERMS,OPERATE,IX,FUNCTN,DIMENSN_DATA,DERIV)
C
C       This subroutine selects the appropriate function category and
C  computes the derivatives for NONLINFIT, taking into account a user
C  defined operation if necessary.
C				Donald H. Gudehus, March, 1986
C
C	X		(C)	The array containing the independent variable
C				values
C	MAXNPOINTS	(C)	The first dimension of the array X
C	DIMENSN_IND	(C)	The second dimension of the array X
C	PARAMETRS	(C)	The array containing the parameters used to
C				evaluate the function
C	FUNCAT		(C)	The function category
C	CHOICE		(C)	The choice determining which function
C				to use within a category
C	CONSTANTTERMS	(C)	The terms which are to be held constant in the
C				solution.  Time is saved if these derivatives
C				are not calculated.
C	OPERATE		(C)	A logical key which determines what to do.
C				If .FALSE., the function is evaluated, if 
C				.TRUE.,  a user defined operation is carried
C				out, e.g. convolution.
C	IX		(C)	An array containing the starting and ending
C				indexes for the data
C	FUNCTN		(R)	The output array for the function.
C	DIMENSN_DATA	(C)	The second dimension of the array FUNCTN
C	DERIV		(R)	The output array containing the derivative
C
	CHARACTER*(*) CHOICE
	INTEGER DIMENSN_IND,DIMENSN_DATA,FUNCAT
	DIMENSION IX(2),PARAMETRS(MAXNUMPARAM),X(MAXNPOINTS,DIMENSN_IND),
	1FUNCTN(MAXNPOINTS,DIMENSN_DATA),
	2DERIV(MAXNPOINTS,MAXNUMPARAM,DIMENSN_DATA)
	LOGICAL CONSTANTTERMS(MAXNUMPARAM),OPERATE
	REAL*8 X,PARAMETRS,FUNCTN,DERIV
C
C  A number of demonstration subroutines are referenced here.  They have
C  FUNCAT < 0.  The user defined subroutines should have FUNCAT > 0, and
C  be name NLDER1, NLDER2, etc.
	IF (FUNCAT.EQ.-1) THEN
	  CALL NLDER_DEMO_1(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,MAXNUMPARAM,
	1 CHOICE,CONSTANTTERMS,OPERATE,IX,FUNCTN,DIMENSN_DATA,DERIV)
	ELSE IF (FUNCAT.EQ.-2) THEN
	  CALL NLDER_DEMO_2(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,MAXNUMPARAM,
	1 CHOICE,CONSTANTTERMS,OPERATE,IX,FUNCTN,DIMENSN_DATA,DERIV)
	ELSE IF (FUNCAT.EQ.-3) THEN
	  CALL NLDER_DEMO_3(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,MAXNUMPARAM,
	1 CHOICE,CONSTANTTERMS,OPERATE,IX,FUNCTN,DIMENSN_DATA,DERIV)
	ELSE IF (FUNCAT.EQ.-4) THEN
	  CALL NLDER_DEMO_4(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,MAXNUMPARAM,
	1 CHOICE,CONSTANTTERMS,OPERATE,IX,FUNCTN,DIMENSN_DATA,DERIV)
	ELSE IF (FUNCAT.EQ.1) THEN
C	  CALL NLDER1(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,MAXNUMPARAM,CHOICE,
C	1 CONSTANTTERMS,OPERATE,IX,FUNCTN,DIMENSN_DATA,DERIV)
	ELSE IF (FUNCAT.EQ.2) THEN
C	  CALL NLDER2(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,MAXNUMPARAM,CHOICE,
C	1 CONSTANTTERMS,OPERATE,IX,FUNCTN,DIMENSN_DATA,DERIV)
	ELSE IF (FUNCAT.EQ.3) THEN
	  CALL NLDER3(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,MAXNUMPARAM,CHOICE,
	1 CONSTANTTERMS,OPERATE,IX,FUNCTN,DIMENSN_DATA,DERIV)
	ELSE IF (FUNCAT.EQ.4) THEN
C	  CALL NLDER4(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,MAXNUMPARAM,CHOICE,
C	1 CONSTANTTERMS,OPERATE,IX,FUNCTN,DIMENSN_DATA,DERIV)
	ELSE IF (FUNCAT.EQ.5) THEN
C	  CALL NLDER5(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,MAXNUMPARAM,CHOICE,
C	1 CONSTANTTERMS,OPERATE,IX,FUNCTN,DIMENSN_DATA,DERIV)
	ELSE IF (FUNCAT.EQ.6) THEN
C	  CALL NLDER6(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,MAXNUMPARAM,CHOICE,
C	1 CONSTANTTERMS,OPERATE,IX,FUNCTN,DIMENSN_DATA,DERIV)
	ELSE IF (FUNCAT.EQ.7) THEN
C	  CALL NLDER7(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,MAXNUMPARAM,CHOICE,
C	1 CONSTANTTERMS,OPERATE,IX,FUNCTN,DIMENSN_DATA,DERIV)
	ELSE IF (FUNCAT.EQ.8) THEN
C	  CALL NLDER8(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,MAXNUMPARAM,CHOICE,
C	1 CONSTANTTERMS,OPERATE,IX,FUNCTN,DIMENSN_DATA,DERIV)
	ELSE IF (FUNCAT.EQ.9) THEN
C	  CALL NLDER9(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,MAXNUMPARAM,CHOICE,
C	1 CONSTANTTERMS,OPERATE,IX,FUNCTN,DIMENSN_DATA,DERIV)
	ELSE IF (FUNCAT.EQ.10) THEN
C	  CALL NLDER10(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,MAXNUMPARAM,CHOICE,
C	1 CONSTANTTERMS,OPERATE,IX,FUNCTN,DIMENSN_DATA,DERIV)
	ELSE IF (FUNCAT.EQ.11) THEN
C	  CALL NLDER11(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,MAXNUMPARAM,CHOICE,
C	1 CONSTANTTERMS,OPERATE,IX,FUNCTN,DIMENSN_DATA,DERIV)
	ELSE IF (FUNCAT.EQ.12) THEN
C	  CALL NLDER12(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,MAXNUMPARAM,CHOICE,
C	1 CONSTANTTERMS,OPERATE,IX,FUNCTN,DIMENSN_DATA,DERIV)
	ELSE IF (FUNCAT.EQ.13) THEN
C	  CALL NLDER13(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,MAXNUMPARAM,CHOICE,
C	1 CONSTANTTERMS,OPERATE,IX,FUNCTN,DIMENSN_DATA,DERIV)
	ELSE IF (FUNCAT.EQ.14) THEN
	  CALL NLDER14(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,MAXNUMPARAM,CHOICE,
	1 CONSTANTTERMS,OPERATE,IX,FUNCTN,DIMENSN_DATA,DERIV)
	END IF
C
	RETURN
	END	
