	SUBROUTINE NLDER_DEMO_1(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,
	1MAXNUMPARAM,CHOICE,CONSTANTTERMS,OPERATE,IX,FUNCTN,
	2DIMENSN_DATA,DERIV)
C
C       This subroutine selects the appropriate function choice and
C  computes the derivatives for NONLINFIT, taking into account a user
C  defined operation if necessary.
C				Donald H. Gudehus, March, 1986
C
C	X		(C)	The array containing the independent variable
C				values
C	MAXNPOINTS	(C)	The first dimension of the array X
C	DIMENSN_IND	(C)	The second dimension of the array X
C	PARAMETRS	(C)	The array containing the parameters used to
C				evaluate the function
C	CHOICE		(C)	The choice determining which function
C				to use within a category
C	CONSTANTTERMS	(C)	The terms which are to be held constant in the
C				solution.  Time is saved if these derivatives
C				are not calculated.
C	OPERATE		(C)	A logical key which determines what to do.
C				If .FALSE., the function is evaluated, if 
C				.TRUE., a user defined operation is carried
C				out, e.g., convolution.
C	IX		(C)	An array containing the starting and ending
C				indexes for the evauation of DERIV
C	FUNCTN		(C)	The output array for the function.
C	DIMENSN_DATA	(C)	The second dimension of the array FUNCTN
C	DERIV		(R)	The ouput array containing the derivative
C
	CHARACTER*(*) CHOICE
	INTEGER DIMENSN_IND,DIMENSN_DATA,IX(2)
	DIMENSION PARAMETRS(MAXNUMPARAM),X(MAXNPOINTS,DIMENSN_IND),
	1FUNCTN(MAXNPOINTS,DIMENSN_DATA),
	2DERIV(MAXNPOINTS,MAXNUMPARAM,DIMENSN_DATA)
	LOGICAL CONSTANTTERMS(MAXNUMPARAM),OPERATE
	REAL*8 X,PARAMETRS,FUNCTN,DERIV
C
	IF (CHOICE.EQ.'K') THEN
	  DO N=IX(1),IX(2)
	    DERIV(N,1,1)=1.0  ! The derivative of the average with respect
			      ! to the parameter is 1.
	  END DO
	ELSE IF (CHOICE.EQ.'L') THEN
	  DO N=IX(1),IX(2)
	    DERIV(N,1,1)=1.0
	    DERIV(N,2,1)=X(N,1)
	  END DO
	ELSE IF (CHOICE.EQ.'T') THEN
	  MPRIME=(PARAMETRS(3)-PARAMETRS(1))/(PARAMETRS(2)-PARAMETRS(4))	
	  DO N=IX(1),IX(2)
	    IF (X(N,1).LE.MPRIME) THEN
	      DERIV(N,1,1)=1.0D0
	      DERIV(N,2,1)=X(N,1)
	    ELSE
	      DERIV(N,3,1)=1.0D0
	      DERIV(N,4,1)=X(N,1)
	    END IF
	  END DO
	END IF
C
	RETURN
	END
