	SUBROUTINE NLDER_DEMO_4(RADIUS,MAXNPOINTS,DIMENSN_IND,PARAMETRS,
	1MAXNUMPARAM,CHOICE,CONSTANTTERMS,OPERATE,IRADII,FUNCTN,
	2DIMENSN_DATA,DERIV)
C
C       This subroutine selects the appropriate function choice and
C  computes the derivatives for NONLINFIT, taking into account a user
C  defined operation if necessary.
C				Donald H. Gudehus, March, 1986
C
C	RADIUS		(C)	The array containing the independent variable
C				values
C	MAXNPOINTS	(C)	The first dimension of the array RADIUS
C	DIMENSN_IND	(C)	The second dimension of the array RADIUS
C	PARAMETRS	(C)	The array containing the parameters used to
C				evaluate the function
C	CHOICE		(C)	The choice determining which function
C				to use within a category
C	CONSTANTTERMS	(C)	The terms which are to be held constant in the
C				solution.  Time is saved if these derivatives
C				are not calculated.
C	OPERATE		(C)	A logical key which determines what to do.
C				If .FALSE., the function is evaluated, if 
C				.TRUE., a user defined operation is carried
C				out, e.g., convolution.
C	IRADII		(C)	An array containing the starting and ending
C				indexes for the evauation of DERIV
C	FUNCTN		(C)	The output array for the function.
C	DIMENSN_DATA	(C)	The second dimension of the array FUNCTN
C	DERIV		(R)	The ouput array containing the derivative
C
	CHARACTER*(*) CHOICE
	INTEGER DIMENSN_IND,DIMENSN_DATA,IRADII(2)
	DIMENSION PARAMETRS(MAXNUMPARAM),RADIUS(MAXNPOINTS,DIMENSN_IND),
	1FUNCTN(MAXNPOINTS,DIMENSN_DATA),
	2DERIV(MAXNPOINTS,MAXNUMPARAM,DIMENSN_DATA)
	LOGICAL CONSTANTTERMS(MAXNUMPARAM),OPERATE
	REAL*8 RADIUS,PARAMETRS,FUNCTN,VFACTOR,DERIV
C
	VFACTOR=3.33*LOG(10.0)
	IF (CHOICE.EQ.'V') THEN
	  DO N=IRADII(1),IRADII(2)
	    DERIV(N,1,1)=(FUNCTN(N,1)-PARAMETRS(3))/PARAMETRS(1)
	    DERIV(N,2,1)=((FUNCTN(N,1)-PARAMETRS(3))*VFACTOR/4.0)*
	1   RADIUS(N,1)**0.25/PARAMETRS(2)**1.25
	    DERIV(N,3,1)=1.0
	  END DO
	END IF
C
	RETURN
	END
