	SUBROUTINE NLFUN14(FR_ANGLE,MAXNPOINTS,DIMENSN_IND,PARAMETRS,
	1CHOICE,OPERATE,IX,FUNCTN,DIMENSN_DATA)
C
C       This subroutine helps NONLINFIT in a least squares fit for the 
C  separation and position angle of a binary star from one-dimensional
C  interferometric data.
C			Donald H. Gudehus, February 23, 2004
C
C	FR_ANGLE	(C)	The array containing the independent variable
C				values
C	MAXNPOINTS	(C)	The first dimension of the array FR_ANGLE
C	DIMENSN_IND	(C)	The second dimension of the array FR_ANGLE
C	PARAMETRS	(C)	The array containing the parameters used to
C				evaluate the function
C	CHOICE		(C)	The choice determining which function
C				to use within a category.  Not used here.
C	OPERATE		(C)	A logical key which determines what to do.
C				If .FALSE., the function is evaluated, if 
C				.TRUE.,  a user defined operation is also 
C				carried	out, e.g. convolution.  Not used
C				here.
C	IX		(C)	An array containing the starting and ending
C				indexes for the evaluation of FUNCTN
C	FUNCTN		(R)	The output array for the function.
C	DIMENSN_DATA	(C)	The second dimension of the array FUNCTN
C
	INTEGER DIMENSN_IND,DIMENSN_DATA
	DIMENSION IX(2),FR_ANGLE(MAXNPOINTS,DIMENSN_IND),
	1PARAMETRS(1),FUNCTN(MAXNPOINTS,DIMENSN_DATA)
	CHARACTER*(*) CHOICE
	LOGICAL OPERATE,PLOT
	REAL*8 FR_ANGLE,PARAMETRS,FUNCTN
C
	REAL*8 SEPARATION,POSITION_ANGLE,PI,DEG_RAD
C
	PI=3.14159265358979D0
	DEG_RAD=180.0D0/PI
C
	CALL ALPHA(%REF(CHOICE),1,LEN(CHOICE),NCHAR,NFULL,NREST,1)
	PLOT=.FALSE.
	IF (CHOICE(NCHAR:NCHAR).EQ.'%') THEN
	  PLOT=.TRUE.
	  CHOICE(NCHAR:NCHAR)=' '
	END IF
C
	SEPARATION=PARAMETRS(1)
	POSITION_ANGLE=PARAMETRS(2)
	DO I=IX(1),IX(2)
	  FUNCTN(I,1)=SEPARATION*ABS(DCOSD(FR_ANGLE(I,1)-PARAMETRS(2)))
	END DO
C
	RETURN
	END
