	SUBROUTINE NLFUN(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,FUNCAT,CHOICE,
	1OPERATE,IX,FUNCTN,DIMENSN_DATA)
C
C       This subroutine helps NONLINFIT by selecting the chosen function
C  category, evaluating it, and returning the answer.
C			Donald H. Gudehus, March, 1986
C
C	X		(C)	The array containing the independent variable
C				values
C	MAXNPOINTS	(C)	The first dimension of the array X
C	DIMENSN_IND	(C)	The second dimension of the array X
C	PARAMETRS	(C)	The array containing the parameters used to
C				evaluate the function
C	FUNCAT		(C)	The number of the function category
C	CHOICE		(C)	The choice determining which function
C				to use within a category
C	OPERATE		(C)	A logical key which determines what to do.
C				If .FALSE., the function is evaluated, if 
C				.TRUE.,  a user defined operation is carried
C				out, e.g. convolution.
C	IX		(C)	An array containing the starting and ending
C				indexes for the evaluation of of FUNCTN
C	FUNCTN		(R)	The output array containing the function.
C	DIMENSN_DATA	(C)	The second dimension of the output array
C
	INTEGER DIMENSN_IND,DIMENSN_DATA,FUNCAT
	DIMENSION X(MAXNPOINTS,DIMENSN_IND),PARAMETRS(1),IX(2),
	1FUNCTN(MAXNPOINTS,DIMENSN_DATA)
	LOGICAL OPERATE
	REAL*8 X,PARAMETRS,FUNCTN
	CHARACTER*(*) CHOICE
C
C  A number of demonstration subroutines are referenced here.  They have
C  FUNCAT < 0.  The user defined subroutines should have FUNCAT > 0, and
C  be name NLFUN1, NLFUN2, etc.
	IF (FUNCAT.EQ.-1) THEN !  Straight lines demo
	  CALL NLFUN_DEMO_1(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,CHOICE,
	1 OPERATE,IX,FUNCTN,DIMENSN_DATA)
	ELSE IF (FUNCAT.EQ.-2) THEN !  Ellipse demo
	  CALL NLFUN_DEMO_2(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,CHOICE,
	1 OPERATE,IX,FUNCTN,DIMENSN_DATA)
	ELSE IF (FUNCAT.EQ.-3) THEN !  Circle demo
	  CALL NLFUN_DEMO_3(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,CHOICE,
	1 OPERATE,IX,FUNCTN,DIMENSN_DATA)
	ELSE IF (FUNCAT.EQ.-4) THEN !  de Vaucouleurs formula demo
	  CALL NLFUN_DEMO_4(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,CHOICE,
	1 OPERATE,IX,FUNCTN,DIMENSN_DATA)
	ELSE IF (FUNCAT.EQ.1) THEN !  NLTEST1.DEV (Replacement for RADGAL
				   !  under development)
C	  CALL NLFUN1(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,CHOICE,OPERATE,IX,
C	1 FUNCTN,DIMENSN_DATA)
	ELSE IF (FUNCAT.EQ.2) THEN
C	  CALL NLFUN2(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,CHOICE,OPERATE,IX,
C	1 FUNCTN,DIMENSN_DATA)
	ELSE IF (FUNCAT.EQ.3) THEN !  BINARY.FOR
	  CALL NLFUN3(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,CHOICE,OPERATE,IX,
	1 FUNCTN,DIMENSN_DATA)
	ELSE IF (FUNCAT.EQ.4) THEN !  REDSHFTMAG
C	  CALL NLFUN4(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,CHOICE,OPERATE,IX,
C	1 FUNCTN,DIMENSN_DATA)
	ELSE IF (FUNCAT.EQ.5) THEN !  NLTEST5.FOR (Speckle binary)
C	  CALL NLFUN5(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,CHOICE,OPERATE,IX,
C	1 FUNCTN,DIMENSN_DATA)
	ELSE IF (FUNCAT.EQ.6) THEN !  DISPGAL.FOR
C	  CALL NLFUN6(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,CHOICE,OPERATE,IX,
C	1 FUNCTN,DIMENSN_DATA)
	ELSE IF (FUNCAT.EQ.7) THEN
C	  CALL NLFUN7(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,CHOICE,OPERATE,IX,
C	1 FUNCTN,DIMENSN_DATA)
	ELSE IF (FUNCAT.EQ.8) THEN
C	  CALL NLFUN8(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,CHOICE,OPERATE,IX,
C	1 FUNCTN,DIMENSN_DATA)
	ELSE IF (FUNCAT.EQ.9) THEN
C	  CALL NLFUN9(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,CHOICE,OPERATE,IX,
C	1 FUNCTN,DIMENSN_DATA)
	ELSE IF (FUNCAT.EQ.10) THEN !  SADFIT.FOR, PROBABLE2D.FOR,
		! GAUSSFIT1D_E.FOR, FAKGAL.FOR
C	  CALL NLFUN10(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,CHOICE,OPERATE,IX,
C	1 FUNCTN,DIMENSN_DATA)
	ELSE IF (FUNCAT.EQ.11) THEN !  SUBSTAR.FOR
C	  CALL NLFUN11(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,CHOICE,OPERATE,IX,
C	1 FUNCTN,DIMENSN_DATA)
	ELSE IF (FUNCAT.EQ.12) THEN !  NLTEST12.FOR
C	  CALL NLFUN12(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,CHOICE,OPERATE,IX,
C	1 FUNCTN,DIMENSN_DATA)
	ELSE IF (FUNCAT.EQ.13) THEN
C	  CALL NLFUN13(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,CHOICE,OPERATE,IX,
C	1 FUNCTN,DIMENSN_DATA)
	ELSE IF (FUNCAT.EQ.14) THEN !  ONE2TWO.FOR
	  CALL NLFUN14(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,CHOICE,OPERATE,IX,
	1 FUNCTN,DIMENSN_DATA)
	ELSE
	  CALL BELL
	  CALL ERROR(-4,'Error in NLFUN')
	END IF
C
	RETURN
	END
