	SUBROUTINE NLFUN_DEMO_2(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,CHOICE,
	1OPERATE,IX,FUNCTN,DIMENSN_DATA)
C
C       This subroutine helps NONLINFIT by selecting the chosen conic
C  section function, evaluating it, taking into account a user defined 
C  operation if necessary, and returning the answer.  In this demonstration
C  subroutine, we calculate the x and y locations on an ellipse.
C			Donald H. Gudehus, March, 1986
C
C	X		(C)	The array containing the independent variable
C				values.  In this case X represents angle around
C				the ellipse.
C	MAXNPOINTS	(C)	The first dimension of the array X
C	DIMENSN_IND	(C)	The second dimension of the array X
C	PARAMETRS	(C)	The array containing the parameters used to
C				evaluate the function
C	CHOICE		(C)	The choice determining which function
C				to use within a category
C	OPERATE		(C)	A logical key which determines what to do.
C				If .FALSE., the function is evaluated, if 
C				.TRUE., a user defined operation is carried
C				out, e.g., convolution.
C	IX		(C)	An array containing the starting and ending
C				indexes for the evaluation of FUNCTN
C	FUNCTN		(R)	The output array for the function.
C	DIMENSN_DATA	(C)	The second dimension of the array FUNCTN
C
	INTEGER DIMENSN_IND,DIMENSN_DATA
	DIMENSION IX(2),X(MAXNPOINTS,DIMENSN_IND),PARAMETRS(1),
	1FUNCTN(MAXNPOINTS,DIMENSN_DATA)
	LOGICAL OPERATE,PLOT
	REAL*8 X,PARAMETRS,FUNCTN,PI,F,CS,SN
	CHARACTER*(*) CHOICE
C
	PI=3.1415926535
	CALL ALPHA(%REF(CHOICE),1,LEN(CHOICE),NCHAR,NFULL,NREST,1)
	PLOT=.FALSE.
	IF (CHOICE(NCHAR:NCHAR).EQ.'%') THEN
	  PLOT=.TRUE.
	  CHOICE(NCHAR:NCHAR)=' '
	END IF
	IF (OPERATE) THEN
	  CALL MESSAGE('SORRY')
	ELSE
	  IF (CHOICE.EQ.'E') THEN
C  Protect against bad values
	    PARAMETRS(2)=MIN(1.0D0,MAX(0.0D0,PARAMETRS(2)))
	    F=SQRT(ABS(1.0-PARAMETRS(2)**2))
	    CS=COSD(PARAMETRS(1))
	    SN=SIND(PARAMETRS(1))	
	    DO N=IX(1),IX(2)
	      FUNCTN(N,1)=PARAMETRS(3)*(COS(X(N,1))*CS-F*SIN(X(N,1))*SN)
	      FUNCTN(N,2)=PARAMETRS(3)*(COS(X(N,1))*SN+F*SIN(X(N,1))*CS)
 	    END DO
	  END IF
	END IF
	RETURN
	END
