	SUBROUTINE NLFUN_DEMO_3(X,MAXNPOINTS,DIMENSN_IND,PARAMETRS,CHOICE,
	1OPERATE,IX,FUNCTN,DIMENSN_DATA)
C
C       This subroutine helps NONLINFIT by selecting the chosen conic
C  section function, evaluating it, taking into account a user defined 
C  operation if necessary, and returning the answer.  In this demonstration
C  subroutine, we calculate the difference in the radius of a circle.  We
C  take this approach rather than calculating the X and Y locations because
C  the independent variable is not present, i.e., only X and Y positions are
C  provided prior to the fit rather than angle, X, and Y.  However when
C  the plot array is filled in a separate call, the array X contains angles
C  which are then used to calculate X and Y.  
C  
C			Donald H. Gudehus, March 3, 2005
C
C	X		(C)	The array containing the independent variable
C				values.  In this case X simply contains an
C				index but is not used in the calculation. 
C				When the plot array is to be filled, X
C				contains angles.
C	MAXNPOINTS	(C)	The first dimension of the array X
C	DIMENSN_IND	(C)	The second dimension of the array X
C	PARAMETRS	(C)	The array containing the parameters used to
C				evaluate the function
C	CHOICE		(C)	The choice determining which function
C				to use within a category
C	OPERATE		(C)	A logical key which determines what to do.
C				If .FALSE., the function is evaluated, if 
C				.TRUE., a user defined operation is carried
C				out, e.g., convolution.
C	IX		(C)	An array containing the starting and ending
C				indexes for the evaluation of FUNCTN
C	FUNCTN		(R)	The output array for the function.
C	DIMENSN_DATA	(C)	The second dimension of the array FUNCTN
C
	INTEGER DIMENSN_IND,DIMENSN_DATA
	DIMENSION IX(2),X(MAXNPOINTS,DIMENSN_IND),PARAMETRS(1),
	1FUNCTN(MAXNPOINTS,DIMENSN_DATA)
	LOGICAL OPERATE,PLOT
	REAL*8 X,PARAMETRS,FUNCTN
	CHARACTER*(*) CHOICE
C
	PARAMETER (MAXNPOINTS_COM=300,DIMENSN_DATA_COM=2)
	REAL*8 POINTS(MAXNPOINTS_COM,DIMENSN_DATA_COM)
	COMMON /SCRATCH_BLOCK/ POINTS
C
	CALL ALPHA(%REF(CHOICE),1,LEN(CHOICE),NCHAR,NFULL,NREST,1)
	PLOT=.FALSE.
	IF (CHOICE(NCHAR:NCHAR).EQ.'%') THEN
	  PLOT=.TRUE.
	  CHOICE(NCHAR:NCHAR)=' '
	END IF
	IF (OPERATE) THEN
	  CALL MESSAGE('SORRY')
	ELSE
	  IF (CHOICE.EQ.'C') THEN
	    DO N=IX(1),IX(2)
	      FUNCTN(N,1)=SQRT((POINTS(N,1)-PARAMETRS(1))**2+(POINTS(N,2)-
	1     PARAMETRS(2))**2)-PARAMETRS(3)
 	    END DO
	    IF (PLOT) THEN
	      DO N=IX(1),IX(2)
	        FUNCTN(N,1)=PARAMETRS(3)*DCOS(X(N,1))+PARAMETRS(1)
	        FUNCTN(N,2)=PARAMETRS(3)*DSIN(X(N,1))+PARAMETRS(2)
	      END DO
	    END IF
	  END IF
	END IF
	RETURN
	END
