	SUBROUTINE NLFUN_DEMO_4(RADIUS,MAXNPOINTS,DIMENSN_IND,PARAMETRS,
	1CHOICE,OPERATE,IRADII,FUNCTN,DIMENSN_DATA)
C
C       This subroutine helps NONLINFIT by selecting the chosen galaxy
C  fitting function, evaluating it taking into account a user defined
C  operation if necessary, and returning the answer.
C			Donald H. Gudehus, March, 1986
C
C	RADIUS		(C)	The array containing the independent variable
C				values
C	MAXNPOINTS	(C)	The first dimension of the array RADIUS
C	DIMENSN_IND	(C)	The second dimension of the array RADIUS
C	PARAMETRS	(C)	The array containing the parameters used to
C				evaluate the function
C	CHOICE		(C)	The choice determining which function
C				to use within a category
C	OPERATE		(C)	A logical key which determines what to do.
C				If .FALSE., the function is evaluated, if 
C				.TRUE., a user defined operation is carried
C				out, e.g., convolution.
C	IRADII		(C)	An array containing the starting and ending
C				indexes for the evaluation of of FUNCTN
C	FUNCTN		(R)	The output array containing the function.
C	DIMENSN_DATA	(C)	The second dimension of the output array
C
	INTEGER DIMENSN_IND,DIMENSN_DATA
	DIMENSION IRADII(2),RADIUS(MAXNPOINTS,DIMENSN_IND),PARAMETRS(1),
	1FUNCTN(MAXNPOINTS,DIMENSN_DATA)
	LOGICAL OPERATE,PLOT
	REAL*8 RADIUS,PARAMETRS,FUNCTN
	CHARACTER*(*) CHOICE
C
	CALL ALPHA(%REF(CHOICE),1,LEN(CHOICE),NCHAR,NFULL,NREST,1)
	PLOT=.FALSE.
	IF (CHOICE(NCHAR:NCHAR).EQ.'%') THEN
	  PLOT=.TRUE.
	  CHOICE(NCHAR:NCHAR)=' '
	END IF
	IF (OPERATE) THEN
C  One could convolve the data to account for seeing
	ELSE
	  IF (CHOICE.EQ.'V') THEN
	    DO N=IRADII(1),IRADII(2)
	      FUNCTN(N,1)=PARAMETRS(1)*10.0**(-3.33*((RADIUS(N,1)/
	1     PARAMETRS(2))**0.25-1.0))
	      FUNCTN(N,1)=FUNCTN(N,1)+PARAMETRS(3)
	    END DO
	  END IF
	END IF
C
	RETURN
	END
